#include <ui/Rect.h>

namespace ui
{
    bool Rect::contains(Point point)
    {
        return (point.x >= pos.x) && (point.y >= pos.y) && (point.x <= (pos.x + width)) &&
               (point.y <= (pos.y + height));
    }

    Point Rect::normalize(Point point)
    {
        if (point.x < pos.x) point.x = pos.x;
        if (point.y < pos.y) point.y = pos.y;
        if (point.x > pos.x + width) point.x = pos.x + width;
        if (point.y > pos.y + height) point.y = pos.y + height;
        return point;
    }

    Rect Rect::absolute()
    {
        return Rect { ui::Point { pos.x < 0 ? 0 : pos.x, pos.y < 0 ? 0 : pos.y }, width, height };
    }
};
